/**************************************************************
** 	ţ
**	LCD
**  汾V1.0  
**	̳www.openmcu.com
**	Աhttp://shop36995246.taobao.com/   
**  ֧Ⱥ121939788 
***************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "hardware.h"
#include "ili932x.h"
#include "Font_Lib.h"	 //ֿļ
#include "hz16.h"

uint16_t POINT_COLOR = WHITE,BACK_COLOR = BLACK;  /* ֱõɫ͵ɫ	*/

/*****************************************************************************
** : LCD_Write_Reg
** : дָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_WriteReg(uint16_t LCD_Reg,uint16_t LCD_Dat)
{
	Write_Cmd(LCD_Reg);
	Write_Dat(LCD_Dat);
}
/*****************************************************************************
** : Write_Cmd
** : дָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Write_Cmd(uint16_t LCD_Reg)
{
	LCD_CS = 0;
	LCD_RS = 0;
	GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Reg&0x00ff);
	GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Reg&0xff00); 
	LCD_WR = 0;
	LCD_WR = 1;	
	LCD_CS = 1;
}
/*****************************************************************************
** : Write_Dat
** : д
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Write_Dat(uint16_t LCD_Dat)
{
	LCD_CS = 0;
	LCD_RS = 1;
	GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Dat&0x00ff);
	GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Dat&0xff00);
	LCD_WR = 0;
	LCD_WR = 1;	
	LCD_CS = 1;
}
/*****************************************************************************
** : LCD_ReadReg
** : ָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t LCD_ReadReg(uint16_t LCD_Reg)
{
	uint16_t temp;
	Write_Cmd(LCD_Reg);  //дҪļĴ  

	GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x44444444; //˿ڸ8λó
	GPIOC->CRL = (GPIOC->CRL & 0x00000000) | 0x44444444; //˿ڵ8λó  
	LCD_CS = 0;
	LCD_RS = 1;
	LCD_RD = 0;
	temp = ((GPIOB->IDR&0xff00)|(GPIOC->IDR&0x00ff)); //ȡ(Ĵʱ,Ҫ2) 	
	LCD_RD = 1;
	LCD_CS = 1; 
	GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x33333333; //ͷŶ˿ڸ8λΪ
	GPIOC->CRL = (GPIOC->CRL & 0x00000000) | 0x33333333; //ͷŶ˿ڵ8λΪ
	return temp;   
}
/*****************************************************************************
** : LCD_ReadDat
** : 
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t LCD_ReadDat()
{
	uint16_t temp;

	GPIOE->CRH = (GPIOE->CRH & 0x00000000) | 0x44444444;  //˿ڸ8λó
	GPIOE->CRL = (GPIOE->CRL & 0x00000000) | 0x44444444;  //˿ڵ8λó
	LCD_CS = 0;
	LCD_RS = 1;
	LCD_RD = 0;
	temp = ((GPIOB->IDR&0xff00)|(GPIOC->IDR&0x00ff));	//ȡ(Ĵʱ,Ҫ2)
	LCD_RD = 1;
	LCD_CS = 1;
	GPIOE->CRH = (GPIOE->CRH & 0x00000000) | 0x33333333;  //ͷŶ˿ڸ8λΪ
	GPIOE->CRL = (GPIOE->CRL & 0x00000000) | 0x33333333;  //ͷŶ˿ڵ8λΪ

	return temp;   
}
/*****************************************************************************
** : LCD_Configuration
** : LCD_IO
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Configuration()
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC,ENABLE);

	/* IO ӵGPIOB *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 
								| GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	/* ÿIO ӵPD12.PD13.PD14.PD15 *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 
								| GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7 
								| GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOC, &GPIO_InitStructure);
}
/*****************************************************************************
** : LCD_Init
** : LCDʼ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Init(void)
{
	static uint16_t DeviceCode;
	LCD_Configuration();
	LCD_WriteReg(0x0000,0x0001);
	LCD_Delay(5); // LCD_Delay 50 ms 
	DeviceCode = LCD_ReadReg(0x0000);   
	printf(" ID=0x%x\n",DeviceCode); 
	if(DeviceCode==0x9325||DeviceCode==0x9328)//ILI9325
	{
		LCD_WriteReg(0x00e7,0x0010);      
        LCD_WriteReg(0x0000,0x0001);//ڲʱ
        LCD_WriteReg(0x0001,0x0100);     
        LCD_WriteReg(0x0002,0x0700);//Դ                    
		//LCD_WriteReg(0x0003,(1<<3)|(1<<4) ); 	//65K  RGB
		//DRIVE TABLE(Ĵ 03H)
		//BIT3=AM BIT4:5=ID0:1
		//AM ID0 ID1   FUNCATION
		// 0  0   0	   R->L D->U
		// 1  0   0	   D->U	R->L
		// 0  1   0	   L->R D->U
		// 1  1   0    D->U	L->R
		// 0  0   1	   R->L U->D
		// 1  0   1    U->D	R->L
		// 0  1   1    L->R U->D .ˮƽ
		// 1  1   1	   U->D	L->R  ֱ
        LCD_WriteReg(0x0003,(1<<12)|(3<<4)|(0<<3) );//65K    
        LCD_WriteReg(0x0004,0x0000);                                   
        LCD_WriteReg(0x0008,0x0207);	           
        LCD_WriteReg(0x0009,0x0000);         
        LCD_WriteReg(0x000a,0x0000);//display setting         
        LCD_WriteReg(0x000c,0x0001);//display setting          
        LCD_WriteReg(0x000d,0x0000);//0f3c          
        LCD_WriteReg(0x000f,0x0000);
		//Դ
        LCD_WriteReg(0x0010,0x0000);   
        LCD_WriteReg(0x0011,0x0007);
        LCD_WriteReg(0x0012,0x0000);                                                                 
        LCD_WriteReg(0x0013,0x0000);                 
        LCD_Delay(5); 
        LCD_WriteReg(0x0010,0x1590);   
        LCD_WriteReg(0x0011,0x0227);
        LCD_Delay(5); 
        LCD_WriteReg(0x0012,0x009c);                  
        LCD_Delay(5); 
        LCD_WriteReg(0x0013,0x1900);   
        LCD_WriteReg(0x0029,0x0023);
        LCD_WriteReg(0x002b,0x000e);
        LCD_Delay(5); 
        LCD_WriteReg(0x0020,0x0000);                                                            
        LCD_WriteReg(0x0021,0x013f);           
		LCD_Delay(5); 
		//٤У
        LCD_WriteReg(0x0030,0x0007); 
        LCD_WriteReg(0x0031,0x0707);   
        LCD_WriteReg(0x0032,0x0006);
        LCD_WriteReg(0x0035,0x0704);
        LCD_WriteReg(0x0036,0x1f04); 
        LCD_WriteReg(0x0037,0x0004);
        LCD_WriteReg(0x0038,0x0000);        
        LCD_WriteReg(0x0039,0x0706);     
        LCD_WriteReg(0x003c,0x0701);
        LCD_WriteReg(0x003d,0x000f);
        LCD_Delay(5); 
        LCD_WriteReg(0x0050,0x0000); //ˮƽGRAMʼλ 
        LCD_WriteReg(0x0051,0x00ef); //ˮƽGRAMֹλ                    
        LCD_WriteReg(0x0052,0x0000); //ֱGRAMʼλ                    
        LCD_WriteReg(0x0053,0x013f); //ֱGRAMֹλ  
        
        LCD_WriteReg(0x0060,0xa700);        
        LCD_WriteReg(0x0061,0x0001); 
        LCD_WriteReg(0x006a,0x0000);
        LCD_WriteReg(0x0080,0x0000);
        LCD_WriteReg(0x0081,0x0000);
        LCD_WriteReg(0x0082,0x0000);
        LCD_WriteReg(0x0083,0x0000);
        LCD_WriteReg(0x0084,0x0000);
        LCD_WriteReg(0x0085,0x0000);
      
        LCD_WriteReg(0x0090,0x0010);     
        LCD_WriteReg(0x0092,0x0000);  
        LCD_WriteReg(0x0093,0x0003);
        LCD_WriteReg(0x0095,0x0110);
        LCD_WriteReg(0x0097,0x0000);        
        LCD_WriteReg(0x0098,0x0000);  
        //ʾ    
        LCD_WriteReg(0x0007,0x0133);   
        LCD_WriteReg(0x0020,0x0000);                                                            
        LCD_WriteReg(0x0021,0x013f); 
	}
	else if(DeviceCode==0x9320||DeviceCode==0x9300)
	{
		LCD_WriteReg(0x00,0x0000);
		LCD_WriteReg(0x01,0x0100);	//Driver Output Contral.
		LCD_WriteReg(0x02,0x0700);	//LCD Driver Waveform Contral.
		LCD_WriteReg(0x03,0x1030);//Entry Mode Set.
		//LCD_WriteReg(0x03,0x1018);	//Entry Mode Set.
	
		LCD_WriteReg(0x04,0x0000);	//Scalling Contral.
		LCD_WriteReg(0x08,0x0202);	//Display Contral 2.(0x0207)
		LCD_WriteReg(0x09,0x0000);	//Display Contral 3.(0x0000)
		LCD_WriteReg(0x0a,0x0000);	//Frame Cycle Contal.(0x0000)
		LCD_WriteReg(0x0c,(1<<0));	//Extern Display Interface Contral 1.(0x0000)
		LCD_WriteReg(0x0d,0x0000);	//Frame Maker Position.
		LCD_WriteReg(0x0f,0x0000);	//Extern Display Interface Contral 2.	    
		LCD_Delay(10); 
		LCD_WriteReg(0x07,0x0101);	//Display Contral.
		LCD_Delay(10); 								  
		LCD_WriteReg(0x10,(1<<12)|(0<<8)|(1<<7)|(1<<6)|(0<<4));	//Power Control 1.(0x16b0)
		LCD_WriteReg(0x11,0x0007);								//Power Control 2.(0x0001)
		LCD_WriteReg(0x12,(1<<8)|(1<<4)|(0<<0));				//Power Control 3.(0x0138)
		LCD_WriteReg(0x13,0x0b00);								//Power Control 4.
		LCD_WriteReg(0x29,0x0000);								//Power Control 7.
	
		LCD_WriteReg(0x2b,(1<<14)|(1<<4));	    
		LCD_WriteReg(0x50,0);	//Set X Star
		//ˮƽGRAMֹλSet X End.
		LCD_WriteReg(0x51,239);	//Set Y Star
		LCD_WriteReg(0x52,0);	//Set Y End.t.
		LCD_WriteReg(0x53,319);	//
	
		LCD_WriteReg(0x60,0x2700);	//Driver Output Control.
		LCD_WriteReg(0x61,0x0001);	//Driver Output Control.
		LCD_WriteReg(0x6a,0x0000);	//Vertical Srcoll Control.
	
		LCD_WriteReg(0x80,0x0000);	//Display Position? Partial Display 1.
		LCD_WriteReg(0x81,0x0000);	//RAM Address Start? Partial Display 1.
		LCD_WriteReg(0x82,0x0000);	//RAM Address End-Partial Display 1.
		LCD_WriteReg(0x83,0x0000);	//Displsy Position? Partial Display 2.
		LCD_WriteReg(0x84,0x0000);	//RAM Address Start? Partial Display 2.
		LCD_WriteReg(0x85,0x0000);	//RAM Address End? Partial Display 2.
	
		LCD_WriteReg(0x90,(0<<7)|(16<<0));	//Frame Cycle Contral.(0x0013)
		LCD_WriteReg(0x92,0x0000);	//Panel Interface Contral 2.(0x0000)
		LCD_WriteReg(0x93,0x0001);	//Panel Interface Contral 3.
		LCD_WriteReg(0x95,0x0110);	//Frame Cycle Contral.(0x0110)
		LCD_WriteReg(0x97,(0<<8));	//
		LCD_WriteReg(0x98,0x0000);	//Frame Cycle Contral.	   
		LCD_WriteReg(0x07,0x0173);	//(0x0173)
		LCD_Delay(10);
	}
	LCD_Clear(BACK_COLOR);
		
}
/*****************************************************************************
** : LCD_DrawPoint
** : дһ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_DrawPoint(uint16_t x,uint16_t y)
{
	LCD_SetCursor(x,y);//ùλ 
	Write_Cmd(R34);//ʼдGRAM
	Write_Dat(POINT_COLOR); 	
}
/*****************************************************************************
** : LCD_WriteRAM_Prepare
** : Щ׼
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_WriteRAM_Prepare()
{
	Write_Cmd(R34);	
}
/*****************************************************************************
** : LCD_SetCursor
** : ù꺯
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_SetCursor(uint8_t Xpos,uint16_t Ypos)
{
	LCD_WriteReg(R32, Xpos);
	LCD_WriteReg(R33, Ypos);	
} 
/*****************************************************************************
** : LCD_SetDisplayWindow
** : ôں (WidthHeightһ£ǰ)
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_SetDisplayWindow(uint8_t Xpos, uint16_t Ypos, uint8_t Height, uint16_t Width)
{
  	LCD_WriteReg(R80, Xpos);	   	   	//ˮƽGRAMʼַ
  	LCD_WriteReg(R81, Xpos+Height); 	//ˮƽGRAMַ 
  	LCD_WriteReg(R82, Ypos);		  	//ֱGRAMʼַ
  	LCD_WriteReg(R83, Ypos+Width);  	//ֱGRAMַ

  	LCD_SetCursor(Xpos, Ypos);			//ùλ
}
/*****************************************************************************
** : LCD_ShowString
** : ʾַ
**   : Dream
** ա  : 20101206
*****************************************************************************/
#define MAX_CHAR_POSX 232
#define MAX_CHAR_POSY 304 
void LCD_ShowString(uint8_t x,uint16_t y,__I uint8_t *p)
{         
    while(*p!='\0')
    {       
        if(x>MAX_CHAR_POSX){x=0;y+=16;}
        if(y>MAX_CHAR_POSY){y=x=0;LCD_Clear(WHITE);}
        LCD_ShowChar(x,y,*p,16,0);
        x+=8;
        p++;
    }  
}
/*****************************************************************************
** : LCD_ShowChar
** : ʾһַ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_ShowChar(uint8_t x,uint16_t y,uint8_t chars,uint8_t size,uint8_t mode)
{
	uint8_t temp;
    uint8_t pos,t;
	uint16_t x1,y1;      
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY) return;	    
											
	LCD_SetDisplayWindow(x,y,(size/2*3),size*3);  //ô

	LCD_WriteRAM_Prepare();        //ʼдGRAM	   
	if(!mode) 						//ǵӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=ASCII_1206[chars-0x20][pos];//1206
			else temp=ASCII_1608[chars-0x20][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {     
		        //if(temp&0x01)            	 			//ȴλȡģйϵ
		        if((temp<<t)&0x80)						//ȴλ
				{
					Write_Dat(RED);
				}
				else 
				{
					Write_Dat(WHITE);	        
		        }
				//temp>>=1; 	   							//ȴλȥ
		    }
		}	
	}
	else//ӷʽ
	{
		for(pos=0;pos<size*3-10;)
		{
		pos=pos+3;
			if(size==12)temp=ASCII_1206[chars-0x20][pos];	//1206
			else temp=ASCII_1608[chars-0x20][pos/3];		 	//1608
			for(t=0;t<size/2*3-8;)
		    { 
			t=t+3;                
		        if((temp<<t/3)&0x80)
				{
				POINT_COLOR = WHITE;
				x1=x+t; y1=y+pos;
				LCD_DrawPoint(x1-1,y1-1);
				LCD_DrawPoint(x1,y1-1);
				LCD_DrawPoint(x1+1,y1-1);
				LCD_DrawPoint(x1-1,y1);
				LCD_DrawPoint(x1,y1);
				LCD_DrawPoint(x1+1,y1);
				LCD_DrawPoint(x1-1,y1+1);
				LCD_DrawPoint(x1,y1+1);
				LCD_DrawPoint(x1+1,y1+1);         
				}
				else
				{
				POINT_COLOR = BLACK;
				x1=x+t; y1=y+pos;
				LCD_DrawPoint(x1-1,y1-1);
				LCD_DrawPoint(x1,y1-1);
				LCD_DrawPoint(x1+1,y1-1);
				LCD_DrawPoint(x1-1,y1);
				LCD_DrawPoint(x1,y1);
				LCD_DrawPoint(x1+1,y1);
				LCD_DrawPoint(x1-1,y1+1);
				LCD_DrawPoint(x1,y1+1);
				LCD_DrawPoint(x1+1,y1+1);
				}
		    }

		}
	}	    
	/* ָС	*/
	LCD_WriteReg(R80, 0x0000); //ˮƽGRAMʼַ
	LCD_WriteReg(R81, 0x00EF); //ˮƽGRAMַ
	LCD_WriteReg(R82, 0x0000); //ֱGRAMʼַ
	LCD_WriteReg(R83, 0x013F); //ֱGRAMַ	
}
void LCD_ShowNum(uint8_t x,uint16_t y,u32 num,uint8_t len,uint8_t size)
{         	
	uint8_t t,temp;
	uint8_t enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/Num_power(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size+10)*t,y,' ',size,1);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size+10)*t,y,temp+'0',size,1); 
	}
}
/*****************************************************************************
** : LCD_Clear
** : Ļ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Clear(uint16_t Color)
{
	uint32_t index=0;      
	LCD_SetCursor(0x00,0x0000); //ùλ 
	LCD_WriteRAM_Prepare();     //ʼдGRAM	 	  
	for(index=0;index<76800;index++)
	{
		Write_Dat(Color);    
	}
}
/*****************************************************************************
** : WriteString
** : ָλÿʼʾһַһ
				֧Զ
**   : Dream
** ա  : 20101206
*****************************************************************************/   			   
void WriteString(uint16_t x0, uint16_t y0,uint8_t *pcStr, uint16_t color)
{
	uint16_t usIndex;
    uint16_t usWidth = 0;
    FNT_GB16 *ptGb16 = 0;
    
    ptGb16 = (FNT_GB16 *)GBHZ_16;  
	while(1)
    {
        if(*pcStr == 0) 
		{
            break;                                     /* ַ            */
        }      
        x0 = x0 + (usWidth);                           /* ַʾɽ         */
        if(*pcStr > 0x80)                              /* жΪ                   */
        {
		    if((x0 + 16) > LCD_W)                      /* ʣռǷ㹻         */
            {
			    x0 = 0;
                y0 = y0 + 16;                          /* ıʾ                 */
                if(y0 > LCD_H)                         /* 곬                   */
                {
				    y0 = 0;
                }
            }
            usIndex = findHzIndex(pcStr);
            usWidth = WriteOneHzChar((uint8_t *)&(ptGb16[usIndex].Msk[0]), x0, y0, color);
                                                       /* ʾַ                     */
            pcStr += 2;
        }
		else 
		{                                               /* жΪǺ                 */
            if (*pcStr == '\r')                         /*                          */
            { 
			    y0 = y0 + 16;                           /* ıʾ                 */
                if(y0 > LCD_H)                          /* 곬                   */
                {
				    y0 = 0;
                }
                pcStr++;
                usWidth = 0;
                continue;
            } 
			else if (*pcStr == '\n')                    /* 뵽                   */
            {
			    x0 = 0;
                pcStr++;
                usWidth = 0;
                continue;
            } 
			else 
			{
                if((x0 + 8) > LCD_W)                     /* ʣռǷ㹻         */
                {
				    x0 = 0;
                    y0 = y0 + 16;                        /* ıʾ                 */
                    if(y0 > LCD_H)                       /* 곬                   */
                    { 
					    y0 = 0;
                    }
                }
                usWidth = WriteOneASCII((uint8_t *)&ASCII_1608[(*pcStr - 0x20)][0], x0, y0, color);
                                                         /* ASCII21HֵӦλ3*/
                pcStr += 1;
            }
		}
	}												  	  
}
/*****************************************************************************
** : WriteOneHzChar
** : ʾһָСĺ
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t WriteOneHzChar(uint8_t *pucMsk,
                               uint16_t x0,
                               uint16_t y0,
                               uint16_t color)
{
    uint16_t i,j;
    uint16_t mod[16];                                      /* ǰģ                     */
    uint16_t *pusMsk;                                      /* ǰַֿ                 */
    uint16_t y;
    
    pusMsk = (uint16_t *)pucMsk;
    for(i=0; i<16; i++)                                    /* 浱ǰֵʽģ       */
    {
        mod[i] = *pusMsk++;                                /* ȡõǰģֶ   */
        mod[i] = ((mod[i] & 0xff00) >> 8) | ((mod[i] & 0x00ff) << 8);/* ģߵֽڣΪʾ   */
                                                           /* Ҫ                       */
    }
    y = y0;
    for(i=0; i<16; i++)                                    /* 16                         */
    { 
	    #ifdef __DISPLAY_BUFFER                            /* ʹԴʾ                 */
        for(j=0; j<16; j++)                                /* 16                         */
        {
		    if((mod[i] << j)& 0x8000)                      /* ʾģ                     */
            {
			    DispBuf[240*(y0+i) + x0+j] = color;
            }
        }
        #else                                              /* ֱʾ                     */
        
        LCD_SetCursor(x0, y);                              /* дݵַָ           */
		LCD_WriteRAM_Prepare();        					   /*ʼдGRAM	*/   
        for(j=0; j<16; j++)                                /* 16                         */
        {
		    if((mod[i] << j) & 0x8000)                     /* ʾģ                     */
            { 
			    Write_Dat(color);
            } 
			else 
			{
                Write_Dat(BACK_COLOR);                     /* öʽдհ׵   */
            	//LCD_ReadDat();
			}
        }
        y++;
        #endif
    }
    return (16);                                          /* 16λп                 */
}
/*****************************************************************************
** : WriteOneASCII
** : ʾһָСַ
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t WriteOneASCII(uint8_t *pucMsk,
                              uint16_t x0,
                              uint16_t y0,
                              uint16_t color)
{
    uint16_t i,j;
    uint16_t y;
    uint8_t ucChar;
    
    y = y0;
    for(i=0; i<16; i++) {                                 /* 16                         */
        ucChar = *pucMsk++;
        #ifdef __DISPLAY_BUFFER                           /* ʹԴʾ                 */
        for(j=0; j<8; j++) {                              /* 8                          */
            if((ucChar << j)& 0x80) {                     /* ʾģ                     */
                DispBuf[240*(y0+i) + x0+j] = color;
            }
        }
        #else                                             /* ֱʾ                     */
        
        LCD_SetCursor(x0, y);                             /* дݵַָ           */
		LCD_WriteRAM_Prepare();        					  /* ʼдGRAM	    		  */
        for(j=0; j<8; j++) {                              /* 8                          */
            if((ucChar << j) & 0x80) {                    /* ʾģ                     */
                Write_Dat(color);
            } else {
                Write_Dat(BACK_COLOR);
				  //LCD_ReadDat();
            }
        }
        y++;
        #endif
    }
    return (8);                                           /* 16λп                 */
}
/*****************************************************************************
** : Num_power
** : MNη
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint32_t Num_power(uint8_t m,uint8_t n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}

/*****************************************************************************
** : LCD_WriteBMP
** : ָλʾһͼƬ
				XposYposΪͼƬʾַHeightWidth ΪͼƬĿȺ͸߶
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_WriteBMP(uint8_t Xpos, uint16_t Ypos, uint8_t Height, uint16_t Width, uint8_t *bitmap)
{
  	uint32_t index;
  	uint32_t size = Height * Width;
  	uint16_t *bitmap_ptr = (uint16_t *)bitmap;

  	LCD_SetDisplayWindow(Xpos, Ypos, Width-1, Height-1);

  	//LCD_WriteReg(0x03, 0x1038);	//ҪʾͼƬȥ ͬʱWidthHightһ¾Ϳ

  	LCD_WriteRAM_Prepare();

  	for(index = 0; index < size; index++)
  	{
    	Write_Dat(*bitmap_ptr++);
  	}
	//ָС	 
	LCD_WriteReg(R80, 0x0000); //ˮƽGRAMʼַ
	LCD_WriteReg(R81, 0x00EF); //ˮƽGRAMַ
	LCD_WriteReg(R82, 0x0000); //ֱGRAMʼַ
	LCD_WriteReg(R83, 0x013F); //ֱGRAMַ
}
/*****************************************************************************
** : LCD_DrawLine
** : ָλûһ
				x1,y1:  x2,y2:յ 
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_DrawLine(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2)
{
	uint16_t t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 

	delta_x=x2-x1; 				// 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; 		//õ 
	else if(delta_x==0)incx=0;	//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;	//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )	// 
	{  
		LCD_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}
/*****************************************************************************
** : LCD_DrawLine
** : ָλûһָСԲ
				(x,y):ĵ 	 r    :뾶
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Draw_Circle(uint8_t x0,uint16_t y0,uint8_t r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		LCD_DrawPoint(x0-b,y0-a);             //3           
		LCD_DrawPoint(x0+b,y0-a);             //0           
		LCD_DrawPoint(x0-a,y0+b);             //1       
		LCD_DrawPoint(x0-b,y0-a);             //7           
		LCD_DrawPoint(x0-a,y0-b);             //2             
		LCD_DrawPoint(x0+b,y0+a);             //4               
		LCD_DrawPoint(x0+a,y0-b);             //5
		LCD_DrawPoint(x0+a,y0+b);             //6 
		LCD_DrawPoint(x0-b,y0+a);             
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		LCD_DrawPoint(x0+a,y0+b);
	}
} 
/*****************************************************************************
** : LCD_Fill
** : ָָɫ
				С:  (xend-xsta)*(yend-ysta) 
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Fill(uint8_t xsta,uint16_t ysta,uint8_t xend,uint16_t yend,uint16_t color)
{                    
    uint32_t n;
	//ô										
	LCD_WriteReg(R80, xsta); //ˮƽGRAMʼַ
	LCD_WriteReg(R81, xend); //ˮƽGRAMַ
	LCD_WriteReg(R82, ysta); //ֱGRAMʼַ
	LCD_WriteReg(R83, yend); //ֱGRAMַ	
	LCD_SetCursor(xsta,ysta);//ùλ  
	LCD_WriteRAM_Prepare();  //ʼдGRAM	 	   	   
	n=(u32)(yend-ysta+1)*(xend-xsta+1);    
	while(n--){Write_Dat(color);}//ʾɫ. 
	//ָ
	LCD_WriteReg(R80, 0x0000); //ˮƽGRAMʼַ
	LCD_WriteReg(R81, 0x00EF); //ˮƽGRAMַ
	LCD_WriteReg(R82, 0x0000); //ֱGRAMʼַ
	LCD_WriteReg(R83, 0x013F); //ֱGRAMַ	    
}
/*****************************************************************************
** : LCD_Delay
** : LCDʱ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Delay (uint32_t nCount)
{
	__IO uint16_t i;	 	
	for (i=0;i<nCount*100;i++);
}
/*********************************************************************************************************
** End of File
*********************************************************************************************************/
