/**************************************************************

**************Temp_Init*************************************************/  

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "hardware.h"
#include "usart.h"
#include "ili932x.h"
#include "rtc.h"
#include "adc.h"



/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

	 
extern uint8_t AsciiBuff[5];
uint16_t  AD_value;
float AD_voltage;
	 
float temperate,temp,Value;
uint16_t  temp_value;

/* Private macro -------------------------------------------------------------*/

static __IO uint32_t TimingDelay;
/* Private variables ---------------------------------------------------------*/
const char menu[] =
   "I'LL BE BACK";
/* Private function prototypes -----------------------------------------------*/
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void Time_Display(uint32_t TimeVar);
uint8_t KEY_Scan(void);
void Delay(__IO uint32_t nTime);

/* Private functions ---------------------------------------------------------*/

/*****************************************************************************

*****************************************************************************/
int main(void)

{
 void OWI_Init(unsigned char pin);
	SystemInit();	   		//ϵͳʱ72M(clock, PLL and Flash configuration)
	while(SysTick_Config(SystemFrequency / 1000));	//Systick ʱn*ms
	GPIO_Configuration();	// 
	USART_Configuration();	//첽ͨųʼ
	NVIC_Configuration();	//ϵͳж
	LCD_Init();				// LCDʼ
	LCD_Clear(BLACK);		//
	Temp_Init();				//¶ȴʼ

	USART_Send_Str(menu);  
    WriteString(2,290,"CPU Temp ",BLUE);				
 	LED2 = 1;
 	while(1)
  	{
	
		
		LCD_ShowNum(10,10,ADC_Filter(0),4,16);    
		LCD_ShowNum(10,50,ADC_Filter(1),4,16);
		LCD_ShowNum(10,100,ADC_Filter(2),4,16);
		LCD_ShowNum(10,140,ADC_Filter(3),4,16);     
		
		AD_voltage= (float)(3.3/4096)*ADC_Filter(8);
		LCD_ShowNum(40,180,(uint8_t)AD_voltage,1,16);	
		AD_voltage-=(uint8_t) AD_voltage;			  	
		LCD_ShowNum(70,180,AD_voltage*100,2,16);

		AD_voltage= (float)(3.3/4096)*ADC_Filter(9);
		LCD_ShowNum(40,230,(uint8_t)AD_voltage,1,16);	
		AD_voltage-=(uint8_t) AD_voltage;			  	
		LCD_ShowNum(80,230,AD_voltage*1000,3,16);
		
		/*AD_voltage= (float)(3.3/4096)*ADC_Filter(16);
		AD_voltage=(1.43-AD_voltage)/0.0043+25;
		LCD_ShowNum(100,270,(uint8_t)AD_voltage,2,16);	
		AD_voltage-=(uint8_t) AD_voltage;			  
		LCD_ShowNum(150,270,AD_voltage*100,2,16); */
		
		temp_value=ADC_Filter(16);
		temp=(float)temp_value*(3.3/4096);
		temperate = temp;
	
		temperate=(1.43-temperate)/0.0043+25;//ǰ¶ֵ	 
		LCD_ShowNum(100,270,(uint8_t)temperate,2,16); //ʾ¶
		temperate-=(uint8_t)temperate;	  			 //ȥ
		LCD_ShowNum(150,270,temperate*100,2,16);//ʾ¶С
		LED2 =!LED2;
		LED1 =!LED1;	
		Delay(0);	  
  	}  
}
/*****************************************************************************
** : GPIO_Configuration
** : IO
**   : Dream
** ա  : 20101217
*****************************************************************************/
void GPIO_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_ADCCLKConfig(RCC_PCLK2_Div6);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_USART1, ENABLE);	// ʹܶ˿ʱӣҪ 
	


	/* PA0 PA1 *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;			//ģʽ
  	GPIO_Init(GPIOA, &GPIO_InitStructure);					//ʼPA0PA1


   	/* USART1 Tx (PA9) */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	 		//ÿ©ģʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		//ƵΪ50MHz
  	GPIO_Init(GPIOA, &GPIO_InitStructure);
    
  	/* USART1 Rx (PA10)  */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	//ģʽ
  	GPIO_Init(GPIOA, &GPIO_InitStructure);

	//PA2 PA3
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2 | GPIO_Pin_3;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;	
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		
  	GPIO_Init(GPIOA, &GPIO_InitStructure);		

	//PB0 PB1                        
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
//	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
    GPIO_Init(GPIOB, &GPIO_InitStructure);


}
/*****************************************************************************
** : KEY_Scan
** : 
				0ûκΰ	  1KEY1 
				 2KEY2 
**   : Dream
** ա  : 20101217
*****************************************************************************/
uint8_t KEY_Scan(void)
{	 
	static uint8_t KEY_UP=1;	//ɿ־	   
	if(KEY_UP&&(KEY1==0||KEY2==0))
	{
		Delay(10);				//ȥ 
		KEY_UP=0;
		if(KEY1==0)return 1;
		else if(KEY2==0)return 2;
	}else if(KEY1==1&&KEY2==1)KEY_UP=1; 	    
	return 0;					//ް
}
/*****************************************************************************
** : Delay
** : Systickʱ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void Delay(__IO uint32_t nTime)
{ 
  TimingDelay = nTime;

  while(TimingDelay != 0);
}
/*****************************************************************************
** : TimingDelay_Decrement
** : SystickжϽ뺯
**   : Dream
** ա  : 20101217
*****************************************************************************/
void TimingDelay_Decrement(void)
{
  if (TimingDelay != 0x00)
  { 
    TimingDelay--;
  }
}
/*****************************************************************************
** : NVIC_Configuration
** : ϵͳжϹ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void NVIC_Configuration(void)
{
	#ifdef  VECT_TAB_RAM  
	  /* Set the Vector Table base location at 0x20000000 */ 
	  NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
	#else  /* VECT_TAB_FLASH  */
	  /* Set the Vector Table base location at 0x08000000 */ 
	  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
	#endif
}
#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval : None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*******************************************************************************
** End of File
********************************************************************************/
