/**************************************************************
** 	ţ
**	ܣLEDʵ
**  汾V1.0  
**	̳www.openmcu.com
**	Աhttp://shop36995246.taobao.com/   
**  ֧Ⱥ121939788 
***************************************************************/  
#include "stm32f10x.h"
#include "hardware.h"
#include "rtc.h"

vu32 TimeDisplay = 0;

uint32_t THH = 0, TMM = 0, TSS = 0;

/*****************************************************************************
** : TIM2_IRQHandler
** : ʱ2жϴ
				1usһ
**   : Dream
** ա  : 20101217
*****************************************************************************/ 
void RTC_Configuration(void)
{
  	/* Enable PWR and BKP clocks */
  	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);

  	/* Allow access to BKP Domain */
  	PWR_BackupAccessCmd(ENABLE);

  	/* Reset Backup Domain */
  	BKP_DeInit();

  	/* Enable LSE */
  	RCC_LSEConfig(RCC_LSE_ON);
  	/* Wait till LSE is ready */
  	while (RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET)
  	{}

  	/* Select LSE as RTC Clock Source */
  	RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);

  	/* Enable RTC Clock */
  	RCC_RTCCLKCmd(ENABLE);

  	/* Wait for RTC registers synchronization */
  	RTC_WaitForSynchro();

  	/* Wait until last write operation on RTC registers has finished */
  	RTC_WaitForLastTask();

  	/* Enable the RTC Second */
  	RTC_ITConfig(RTC_IT_SEC, ENABLE);

  	/* Wait until last write operation on RTC registers has finished */
  	RTC_WaitForLastTask();

  	/* Set RTC prescaler: set RTC period to 1sec */
  	RTC_SetPrescaler(32767); /* RTC period = RTCCLK/RTC_PR = (32.768 KHz)/(32767+1) */

  	/* Wait until last write operation on RTC registers has finished */
  	RTC_WaitForLastTask();
}
/*****************************************************************************
** : Time_Show
** : RTCʾ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void Time_Show(void)
{
  	printf("\n\r");
    WriteString(10,280,"ʵʱʱ:  :  :  ",BLUE);	
  	/* Infinite loop */
  	while (1)
  	{
    	/* If 1s has paased */
    	if (TimeDisplay == 1)
    	{
      		/* Display current time */
      		Time_Display(RTC_GetCounter());
      		TimeDisplay = 0;
    	}
		LCD_ShowNum(80,280,THH,2,16);
		LCD_ShowNum(104,280,TMM,2,16);
		LCD_ShowNum(128,280,TSS,2,16);
  }
}
/*****************************************************************************
** : Time_Display
** : ʾǰʱ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void Time_Display(uint32_t TimeVar)
{
  	/* Compute  hours */
  	THH = TimeVar / 3600;
  	/* Compute minutes */
  	TMM = (TimeVar % 3600) / 60;
  	/* Compute seconds */
  	TSS = (TimeVar % 3600) % 60;

  	printf("Time: %0.2d:%0.2d:%0.2d\r", THH, TMM, TSS);
}
/*****************************************************************************
** : Time_Adjust
** : ǰʱ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void Time_Adjust(void)
{
  	/* Wait until last write operation on RTC registers has finished */
  	RTC_WaitForLastTask();
  	/* Change the current time */
  	RTC_SetCounter(Time_Regulate());
  	/* Wait until last write operation on RTC registers has finished */
  	RTC_WaitForLastTask();
}
/*****************************************************************************
** : Time_Regulate
** : ͨʱ
					ʱ
**   : Dream
** ա  : 20101217
*****************************************************************************/
uint32_t Time_Regulate(void)
{
  	uint32_t Tmp_HH = 0xFF, Tmp_MM = 0xFF, Tmp_SS = 0xFF;

  	printf("\r\n==============Time Settings=====================================");
  	printf("\r\n  Please Set Hours");
  	while (Tmp_HH == 0xFF)
  	{
    	Tmp_HH = USART_Scanf(23);
  	}
  	printf(":  %d", Tmp_HH);
  	printf("\r\n  Please Set Minutes");
  	while (Tmp_MM == 0xFF)
  	{
    	Tmp_MM = USART_Scanf(59);
  	}
  	printf(":  %d", Tmp_MM);
  	printf("\r\n  Please Set Seconds");
  	while (Tmp_SS == 0xFF)
  	{
    	Tmp_SS = USART_Scanf(59);
  	}
  	printf(":  %d", Tmp_SS);	 

  	/* Return the value to store in RTC counter register */
  	return((Tmp_HH*3600 + Tmp_MM*60 + Tmp_SS));
}
/*****************************************************************************
** : USART_Scanf
** : 뺯
					ʱ
**   : Dream
** ա  : 20101217
*****************************************************************************/
uint8_t USART_Scanf(uint32_t value)
{
  	uint32_t index = 0;
  	uint32_t tmp[2] = {0, 0};

  	while (index < 2)
  	{
    	/* Loop until RXNE = 1 */
    	while (USART_GetFlagStatus(USART1, USART_FLAG_RXNE) == RESET)
    	{}
    	tmp[index++] = (USART_ReceiveData(USART1));
    	if ((tmp[index - 1] < 0x30) || (tmp[index - 1] > 0x39))
    	{
      		printf("\n\rPlease enter valid number between 0 and 9");
      		index--;
    	}
  	}
  	/* Calculate the Corresponding value */
  	index = (tmp[1] - 0x30) + ((tmp[0] - 0x30) * 10);
  	/* Checks */
  	if (index > value)
  	{
    	printf("\n\rPlease enter valid number between 0 and %d", value);
    	return 0xFF;
  	}
  	return index;
}
/*****************************************************************************
** : RTC_IRQHandler
** : RTCжϺ
					ʱ
**   : Dream
** ա  : 20101217
*****************************************************************************/
void RTC_IRQHandler(void)
{
  	if (RTC_GetITStatus(RTC_IT_SEC) != RESET)
  	{
    	/* Clear the RTC Second interrupt */
    	RTC_ClearITPendingBit(RTC_IT_SEC);

		LED1 =!LED1;  //LED1ת

    	/* Enable time update */
    	TimeDisplay = 1;

    	/* Wait until last write operation on RTC registers has finished */
    	RTC_WaitForLastTask();
    	/* Reset RTC Counter when Time is 23:59:59 */
    	if (RTC_GetCounter() == 0x00015180)
    	{
      	RTC_SetCounter(0x0);
      	/* Wait until last write operation on RTC registers has finished */
      	RTC_WaitForLastTask();
    	}
  	}
}
/*******************************************************************************
** End of File
********************************************************************************/
